<?php
/**
* Sampreg FTP version v1.0
*
* An example of how to correspond with an ftp server to make SA:MP registrations.
* This script will work for a godfather registration.
*
* Copyright (C) 2008 Jesper Jeeninga
*
*   This program is free software: you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation, either version 3 of the License, or
*   (at your option) any later version.
*
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with this program.  If not, see http://www.gnu.org/licenses/.
*/

$ftp_server = "your.ftp.server.name.here";
$ftp_port = 21;
$ftp_user_name = "user";
$ftp_user_pass = "password";
$ftp_remote_dir = "samp/scriptfiles"; //the path to the scriptfiles dir, starting in the ftp home directory

$local_tmp_dir = ""; //You should be allowed to write here! for linux try "/tmp/". Default is the current execution directory.

if (isset($_POST['Register'])) {
	if(isset($_POST['Nick']) && isset($_POST['Age']) && is_numeric($_POST['Age']) && isset($_POST['Password'])) {
		$filename = $_POST['Nick'] . ".ini"; //file to save to
		$file = fopen($local_tmp_dir . $filename, "w");
		if (!$file) {
			echo "Error: Could not write to file";
			return;
		}
		//connect and login to ftp
		$conn_id = ftp_connect($ftp_server, $ftp_port);
		// login with username and password
		$login_result = ftp_login($conn_id, $ftp_user_name, $ftp_user_pass);
		$chdir_result = ftp_chdir($conn_id, $ftp_remote_dir);
		if(!$login_result || !$chdir_result) {
			echo "Error: Could not connect to ftp server";
			fclose($file);
			return;
		}
		//try to get the userfile, if succesfull, the user already registered.
		if ( @ftp_get($conn_id, $local_tmp_dir . "remove.me", $filename, FTP_ASCII) ) {
			unlink($local_tmp_dir . "remove.me");
			echo "Error: User already registered";
			fclose($file);
			return;
		}
		// create an array of the password
		$pass = preg_split('//', $_POST['Password'], -1, PREG_SPLIT_NO_EMPTY);
		$cryptpass = "";
		// Copy the godfather password encryption algorithm
		for($i=0; $i < sizeof($pass); $i++) {
			$char = ord($pass[$i]);
			$char += (3^$i) * ($i % 15);
			//echo $char . "<br>";
			if ($char > 0xff) {
				$char -= 256;
			}
			$cryptpass .= chr($char);
		}
		$message = 
			"Key=".$cryptpass."\n". // Password (must be first line of the file)
			"Registered=1\n". // Registered
			"Sex=".$_POST['Gender']."\n". // Gender (1=mail, 2=female)
			"Age=".$_POST['Age']."\n". // Age
			"Origin=".$_POST['Origin']."\n". // Origin (1=USA, 2=Europe, 3=Asia)
			"Tutorial=".$_POST['Tutorial']."\n"; // Tutorial
		if( !fwrite($file, $message) ) {
			echo "Error: Could not write to file";
			fclose($file);
			ftp_close($conn_id);
			return;
		}
		fclose($file);
		if (!ftp_put($conn_id, $filename, $local_tmp_dir . $filename, FTP_ASCII)) {
			echo "Error: Could not upload file";
			ftp_close($conn_id);
			return;
		}
		else {
			echo "User registered";
		}
		ftp_close($conn_id);
		exit(1);
	}
	else {
		echo "Error: Please fill in all fields";
	}
}
// HTML Logic
?>
<form method=post>
<table>
<tr>
 <td>Nick:</td>
 <td><input type=text name="Nick"></td>
</tr>
<tr>
 <td>Password: </td>
 <td><input type=password name="Password"></td>
</tr>
<tr>
 <td>Gender: </td>
 <td><select name="Gender"><option value="1">male</option><option value="2">female</option></select></td>
</tr>
<tr>
 <td>Age: </td>
 <td><input type=text name="Age"></td>
</tr>
<tr>
 <td>Origin: </td>
 <td><select name="Origin"><option value="1">USA</option><option value="2">Europe<option value="2">Asia</select></td>
</tr>
<tr>
 <td>Tutorial: </td>
 <td><select name="Tutorial"><option value="0">Yes</option><option value="1">No</option></select></td>
</tr>
<tr><td></td><td><input type=submit value="Register" name="Register"></td></tr>
</table>
</form>